{-----------------------------------------------------------------------------}
{ Assembly compiler/lister implementation part.                  (c) 1992 YGP }

  (*) segment (*)
  procedure {$ifdef lst} listing {$else} assembly {$endif};
    label end_line, inv_directive, check_endline;

    const c_buffsz = (*)300 {         }
		     {*)10000{*};

                                                                  {$ifdef lst}
    type lst_ctype = (_lst_none,                  {     }
		      _lst_equ,                        { list help info only }
		      _lst_nbytes,                                  {  DS }
                      _lst_bytes,   {  ,      byte expr }
                      _lst_words,             {      }
                      _lst_longs,                        {      }
                      _rel_byte,    {     branch  }

                      _CPU_byte,       {   CPU  [ ()] }
		      _CPU_word);         { [,    ] }
							              {$endif}

    type APC_rec = record
           PC,                                            {   }
           _alg,                                    {      }
           _mod,                                  {      }
           _rem: cardinal;                 {     }
         end { APC_rec };

    var local_label: boolean;         {        }
        APC, _APC:   APC_rec;   { APC       APC }
        ndx:         cardinal;                             { index in cd_buff }
        sv_psize:    shortcard;
        sv_pname:    packed_name;
        lab_name:    ident_str;                                    {$ifdef lst}
        has_prefix:  byte;
        lst_code:    lst_ctype;        {     (   ) }
        sv_codesz:   cardinal;  {          }
        list:        text;       { file       } {$else}
        reserved:    cardinal; { number of bytes reserved for public/external }
                                                                       {$endif}

        sec_nesting: cardinal;                            { for error recover }
        sec_apc:     APC_rec;                      {   section APC }

        cd_buff:     packed array [0..c_buffsz-1] of byte;

								  {$ifNdef lst}
    var chk_offset:  longint;

    procedure change_byte(offset: cardinal; b: byte);                  forward;
    procedure change_word(offset: cardinal; w: word);                  forward;
								       {$endif}

    {$I expression.pas }                     { parse and calculate expression }
    {$I   gen_code.pas }                         { generate code } {$ifdef lst}
    {$I  list_line.pas }                { print listing for one line } {$endif}
    {$I asm_labels.pas }                         { define local/global labels }
    {$I   instr_68.pas }                         { handle MC68xx instructions }
    {$I directives.pas }                                  { handle directives }

  begin { listing/assembly }                                       {$ifdef lst}
    (*) rewrite(list, lst_fname^);
    {*) assign(list, lst_fname^); rewrite(list); {*}
    has_prefix:= 0;
    if IOresult <> 0 then begin
      err_str:= lst_fname; error(e_open);
    end { if };    						        {$else}
    chk_offset:= -1; rf:= nil; cf:= nil; reserved:= 0;                 {$endif}

    with APC do begin            {         }
      pc:= 0; _alg:= 0; _mod:= 1; _rem:= 0;
      if c_flags and _c_pgm_file <> 0 then
        _mod:= $100
      else if c_flags and (_c_bin_file + _c_cmd_file) <> 0 then begin
        pc:= $100; _alg:= $100; _mod:= 0;
      end { if };
    end { with };
    sec_nesting:= 0;
    {$ifdef lst} ndx:= c_buffsz;
    {$else}      ndx:= 0;       {$endif}
    code_size:= 0;
    repeat {$ifdef lst} sv_codesz:= code_size; lst_code:= _lst_none; {$endif}
      local_label:= lvl <> nil; sv_psize:= 0; _APC:= APC;
      if sy > comment_line then begin                    { skip comment lines }
        case sy of
          period: { OK instruction or directive };
          space_sy: insy;   { new line starts with spaces, so get next symbol }

          ident: begin { new line starts with an identifier, so preserve name }
            if cc_compile = cc_level then begin  { check for conditional comp }
	      lab_name:= idnm; sv_psize:= pack_size; sv_pname:= pack_name;
            end { if };
            insy;                                       { and get next symbol }
            if sy = colon then begin              { label: means global label }
              local_label:= false; insy;  {      ... }
            end { if };
          end { when identifier };

        else(*):(*){ new line does not start with one of the possible symbols }
          error(e_inv_lab); goto end_line;    { report an error and skip line }
        end { case };

        case sy of
	  eol_sy, comment_line: begin               { empty line (or comment) }
	    if sv_psize <> 0 then begin
	      define_label(_apc, sv_psize, sv_pname);
	    end { if };
	    goto end_line;
          end { when comment or empty line };

          equ_sy: begin                           { directive '=' encountered }
            if cc_compile <> cc_level then
              goto end_line
            else begin
              insy; local_label:= false;           { '=' defines global label }
              if sy = equ_sy then begin          { '==' is local eq directive }
                insy; local_label:= true;
              end { if };
              do_equ;
            end { if };
          end { when '=' };

          period, ident: begin            { possible instruction or directive }
            if sy <> period then
              search_cmd                           { find command (directive) }
            else begin
              insy;  { skip period and get next token (must be an identifier) }
              if sy <> ident then         {       }
                error(e_directive)                 {    }
              else begin    {          }
                search_cmd;                        { find command (directive) }
                if not (sy in [instr_sy, alter_sy, drctv_sy]) then begin
                  error(e_directive)     {   / (--) }
                end { if };
              end { if };
            end { if };

            case sy of
              instr_sy, alter_sy: begin {   ,   }
                if cc_compile <> cc_level then     {     }
                  goto end_line               { false conditional compilation }
		else begin            {         }
		  if sv_psize <> 0 then begin              {    }
		    define_label(_apc, sv_psize, sv_pname);
		  end { if };
                  insy;           {        }
                  _68_instruction;   {    MC68xx  }
                end { if };
              end { when instruction };

              drctv_sy: begin            {      }
                if cc_compile <> cc_level then begin{ FALSE conditional comp }
                    {             }
                    {    (else, endif, ifdef, ...).       }

                  case drctv of
                    d_ifdef,
                    d_ifndef,
                    d_if: inc(cc_level);

                    {d_elsif,}
                    {d_elsifdef,}
                    {d_elsifNdef,}
                    d_else: begin
                      if cc_level = 0 then
                        error(e_else_u)
                      else begin
                        insy;
                        if cc_compile+1 = cc_level then begin
                          inc(cc_compile);
                          {if drctv <> d_else then begin
                            insy; do_elsif;
                          end { if };
                        end { if };
                      end { if };
                      goto check_endline;
                    end { when else/elsif/elsifdef/elsifNdef };

                    d_endif: begin
                      if cc_level = 0 then
                        error(e_endifu)
                      else begin
                        insy; dec(cc_level);
                      end { if };
                      goto check_endline;
                    end { when endif };
                  end { case };
                  goto end_line; end
                else begin                     { TRUE conditional compilation }
                          {        . }
                    {    [equ, ... ]     }
		  if not (drctv in [d_equ, d_procedure, d_endproc]) and
		     (sv_psize <> 0) then begin
                    define_label(_apc, sv_psize, sv_pname);
                  end { if };
                  (*  ( )  -
                  if not (drctv in [d_include]) then begin
                  *)
                  if drctv <> d_include then begin
                    insy;               {      }
                  end { if };
                  case drctv of
                    {d_MC6800:   ;}
                    {d_MC6801:   ;}
                    {d_MC68HC11: ;}

                    d_end: begin                                       { .end }
                      do_end; sy:= end_asm;      { emulate end of source file }
                    end { when end };

                    d_equ: begin                                       { .equ }
                      local_label:= false;
                      do_equ;
                    end { when EQU };

		    d_org:	 do_org;	                       { .org }
                    d_procedure: do_procedure;                        { .proc }
                    d_endproc:   do_endproc;                          { .endp }
                    d_section:   do_section;                       { .section }
		    d_endsect:   do_ends;                             { .ends }
		    d_error:	 do_error;                           { .error }
		    d_chksum:	 do_checksum;                     { .checksum }

                    d_def_fcc:  begin                                  { .fcc }
		      do_def(d_FCC, 1 {$ifdef lst}, _lst_bytes {$endif});
		    end { when define byte };

                    d_def_byte:  begin                                  { .db }
		      do_def(d_DB, 1 {$ifdef lst}, _lst_bytes {$endif});
		    end { when define byte };

		    d_def_lbyte:  begin                                { .lsb }
		      do_def(d_LSB, 1 {$ifdef lst}, _lst_bytes {$endif});
		    end { when define LO byte };

                    d_def_hbyte: begin                                 { .msb }
		      do_def(d_MSB, 1 {$ifdef lst}, _lst_bytes {$endif});
                    end { when define HIGH byte };

                    d_def_pword,                                       { .dwp }
                    d_def_word: begin                                   { .dw }
		      do_def(d_DWP, 2 {$ifdef lst}, _lst_words {$endif});
                    end { when define positive word };

                    d_def_nword: begin                                 { .dwn }
		      do_def(d_DWN, 2 {$ifdef lst}, _lst_words {$endif});
                    end { when define positive word };

		    d_def_plong,                                       { .ddp }
		    d_def_long: begin                                   { .dd }
		      do_def(d_DLP, 4 {$ifdef lst}, _lst_longs {$endif});
                    end { when define positive word };

		    d_def_nlong: begin                                 { .ddn }
		      do_def(d_DLN, 4 {$ifdef lst}, _lst_longs {$endif});
                    end { when define positive word };

		    d_def_space: do_DS;	                                { .ds }

		    d_include:    do_include;                      { .include }
                    d_list:       do_list;                            { .list }
                    d_as11:       do_as11;                            { .as11 }
                    d_intelbin:   do_intelbin;
                    d_trunc_list: do_trunc_list;                     { .trunc }

                    d_define:     do_define;                        { .define }
                    d_undef:      do_undef;                          { .undef }

                    d_ifdef,                                         { .ifdef }
                    d_ifNdef,                                       { .ifNdef }
                    d_if: begin                                         { .if }
                      inc(cc_level);
                      inc(cc_compile);
                      do_if_elsif;
                    end { when if/ifdef/ifndef };

                    {d_elsif,}
                    {d_elsifdef,}
                    {d_elsifNdef,}
                    d_else: begin                                     { .else }
                      if cc_level = 0 then
                        error(e_else_u)
                      else begin
                        dec(cc_compile);
                      end { if };
                    end { when else };

                    d_endif: begin                                   { .endif }
                      if cc_level = 0 then
                        error(e_endifu)
                      else begin
                        dec(cc_level);
                        dec(cc_compile);
                      end { if };
                    end { when endif };
                  else(*):(*)
                    goto inv_directive;
                    { if sy <> eof_sy then sy:= comment_line; }
                  end { case };
                end { if };
              end { when directives };

            else(*):(*)         {    ,  ,  }
              goto inv_directive;
            end { case };
          end { when identifier (or period) };

        else (*):(*)
      inv_directive:   {            }
          if cc_compile = cc_level then begin          {    true }
            error(e_inv_instr);                          {  ---- }
          end { if };
          goto end_line;               {        }
        end { case };
      end { if };

    check_endline:
      if sy > comment_line then begin
        error(e_garbage);
      end { if };

    end_line:
      skip_line;                          {       }
      {$ifdef lst}
        list_line;
      {$endif}
      new_line;                                  {      }
    until sy < end_asm;
    {          (endp-) }
    {    ,   ,  .. }
    (*) {*) (*$ifdef lst*) close(list); if ioresult <> 0 then ; (*$endif*){*}

    (* writeln; writeln('finishing ', {$ifdef lst} 'listing ',
			       {$else}      'assembly',
			       {$endif}     ' pass ...');
    *)
								  {$ifNdef lst}
    FinishUp;                                                          {$endif}
    if inc_nesting <> 0 then close_include;
  end { listing/assembly };

{-----------------------------------------------------------------------------}
