{----------------------------------------------------------------------------}
{ Mnemonic of error numbers.                                    (c) 1992 YGP }

{                }
{ .  e_ds_range (   )  e_outrng (       }
{   )  .. }

  const e_no_error =    0;
        w_patched =     1;         {    patch (1..5) }
        w_not_byte =    1;                     { warning: not a byte operand }
        w_not_word =    2;                     { warning: not a word operand }
        w_null_str =   10;                       { warning: null string ('') }

        e_errors =    100;                          { errors begin from here }
	e_usr_error = 100;                             { user error (.error) }
        e_inv_ch =    101;                { invalid character in source code }
        e_inv_lab =   102;                              { invalid label name }
        e_inv_instr = 103;                   { invalid instruction/directive }
        e_garbage =   104; { extra garbage on line (eol or comment expected) }
        e_inv_num =   105;   { invalid number (i.e. $123. or %123h or $123h) }
        e_inv_dies =  106;                { invalid address mode (immediate) }
        e_inv_ndx =   107;                  { invalid address mode (indexed) }
        e_comma =     108;                                  { comma expected }
        e_factor  =   109;                             { error in expression }
        e_r_par =     110;                                    { ')' expected }
        e_express =   111;             { error in expression (extra garbage) }
        e_xcomma =    112;    { exctra comma on line (   ) }
        e_r_bra =     113;                                      { ] expected }
        e_inv_lst =   114;                             { invalid list option }
        e_cnst2lrg =  115;                              { constant too large }
        e_str2long =  116;                                 { string too long }
        e_strexceed = 117;     { string exceeds source line (no close quote) }
        e_inv_brnch = 118;           { invalid operand of branch instruction }
        e_redef =     119;  { label redefinition (in current or parent proc) }
	e_outrng =    120;     { value out of range (on branch instructions) }
	e_ds_range =  121;            { value out of range (on DS directive) }
	e_def_range = 122;	{ value out of range (on DB/W ... directive) }
	e_no_str =    123;                        { strings not allowed here }
        e_notrel =    124;                         { operand is not relative }
        e_sec_range = 125;       { value out of range (on SECTION directive) }
        e_directive = 126;             { directive (or instruction) expected }
        e_ident_exp = 127;                             { identifier expected }
        e_inv_trnc =  128;                      { invalid truncate parameter }
        e_inv_type =  129;                         { invalid expression type }
        e_sec_nest =  130;                     { nested sections not allowed }
        e_ends_ex =   131;                                   { ENDS expected }
	e_no_sect =   132;                            { ends without section }
	e_org_expr =  133;             { invalid expression in org directive }
	e_org_range = 134;        { expression out of range in ORG directive }
	e_sec_expr =  135;         { invalid expression in section directive }
        e_undecl =    136;                           { undeclared identifier }
	e_unresolv =  137;                           { unresolved identifier }
	e_divzer =    138;                                { division by zero }
        e_inv_sum =   139;              { .CHECKSUM in pgm/obj or second use }
        e_mpl2many =  140;          { too many ( )  }
	e_inv_mpl =   141;                        {   }
	e_def_size =  142;         {       }
        e_inv_Zpg =   143;                 { invalid address mode (zeropage) }
        e_inv_Abs =   144;                 { invalid address mode (absolute) }
        e_inv_as11 =  145;                             { invalid as11 option }

        e_patched =   200-16;  { (6..15)    patch (190..199) }

        e_fatal =     200;              {       }
        e_read_src =  201;                       { error reading source code }
        e_no_file =   202;                         { can't find include file }
        e_line2long = 203;                            { source line too long }
        e_empty_fnm = 204;     { filename not specified in include directive }
        e_endife  =   205;                                  { endif expected }
        e_endifu  =   206;                     { unexpeceted endif directive }
        e_else_u =    207;                { unexpeceted else/elsif directive }
        e_unexp_end = 208;                        { unexpected END directive }
        e_endp_e =    209;                                   { ENDP expected }
        e_unendp =    210;                       { unexpected ENDP directive }
        e_cln_pnm =   211;{  :     (. bz: endp) }
	e_pnm_mtch =  212;   {    endp      proc }
	e_fkind =     213;       {          }
	e_if_expr =   214;           {   IF     }

        e_2files =    249;                          { too many include files }
        e_rename =    250;                {      }
        e_close =     251;                    {      }
        e_open =      252;  {        /  }
        e_write =     253;        {          }
        e_patch =     254;        {        }
        e_lst_io =    255;            {        }

{*** System errors (shoud not occure) ***************************************}

        se_dcmd1 = -1;
        se_dcmd2 = -2;
        se_dcmd3 = -3;
        se_ddir1 = -4;
        se_ddir2 = -5;
        se_ddir3 = -6;
        se_ddir4 = -7;
        se_fno   = -8;
        se_ifdef = -9;

        se_db1   = -100;

        se_insy1 = -140;
        se_insy2 = -141;

        se_cnglb = -150;

	se_calc =  -160;

	se_mkv =   -170;

	se_dt_iu = -180;

        se_ce =    -190;

        se_xrf =   -200;
{-----------------------------------------------------------------------------}