{-----------------------------------------------------------------------------}
{ Assembling 68xx instructions.                                  (c) 1992 YGP }

    procedure gen_prefix(prefix, mode: byte);
      const immediate: string  = #$00#$00#$18#$1a;
            ZeroPage: string   = #$00#$00#$18#$1a;
            indexedX: string   = #$00#$00#$1a#$1a;
            indexedY: string   = #$18#$cd#$18#$cd;
            ABSaddress: string = #$00#$00#$18#$1a;
    begin { gen_prefix }
      case mode of
        _i_wrd: prefix:= ord(immediate[prefix+1]);
        _i_imd: prefix:= ord(immediate[prefix+1]);
        _i_Zpg: prefix:= ord(ZeroPage[prefix+1]);
        _i_ndx: prefix:= ord(indexedX[prefix+1]);
           $80: prefix:= ord(indexedY[prefix+1]);
        _i_abs: prefix:= ord(absaddress[prefix+1]);
             0: prefix:= 0 {?};
        _i_rel: prefix:= 0 {?};
      end { case };

      {$ifdef lst}  {            }
        has_prefix:= prefix;
        if prefix <> 0 then begin
          inc(APC.pc, 1);
          if c_flags and _c_section = 0 then begin
            inc(code_size, 1);
          end { if };
        end { if };
      {$else}
        if prefix <> 0 then begin
          gen_byte(prefix);
        end { if };
      {$endif}
    end { gen_prefix };

    procedure _68_instruction;
      var force_mode: byte; sv_pc: word;
          byte_op, skip_expr, xndx, bracket_mode, special_opcodes: boolean;
          add_for_Zpg, add_for_Ndx: byte;
          i_flags, i_prefix, i, special_pass, special_prefix: byte;
    begin { _68_instruction }
      {                 }
      {  ,    ...      }
      {   (     .                  }

      i_flags:= i_descr.flags and $3f;
      i_prefix:= (i_descr.flags and $c0) div 64;

      {    BRset BRclr Bset Bclr }

      special_opcodes:= ($12 <= i_descr.opcode) and (i_descr.opcode <= $15);
      special_pass:= 0;
      if not special_opcodes then begin
        add_for_Zpg:= $10; add_for_Ndx:= $20; end
      else begin
        add_for_Zpg:= 0;
        if i_descr.opcode <= $13 then
          add_for_Ndx:= $0c
        else begin
          add_for_Ndx:= $08
        end { if };
      end { if };

      {$ifdef lst}
        has_prefix:= 0;
      {$endif}
      repeat inc(special_pass);
        if special_opcodes then begin
          case special_pass of
            1: i_flags:= _i_Zpg or _i_ndx; { expect ZeroPage or Indexed mode }

            2: begin
              i_flags:= _i_imd;                      { expect immediate mode }
              force_mode:= _i_imd;                    { force immediate mode }
              if sy = dies then insy;                    { skip # if presant }
              i_prefix:= 0;         { and say there is no prefix }{$ifdef lst}
              special_prefix:= has_prefix    { preserve prefix value }{$endif}
            end { when 2 pass };

            3: begin
              if sy = comma then insy;
              force_mode:= _i_rel;
              i_flags:= _i_rel;                       { expect relative mode }
            end { if };
          end { case };
        end { if };

        if i_flags = $00 then begin{ (implied mode)    }
          {$ifdef lst}  {            }
            has_prefix:= i_prefix; i:= 1+ord(has_prefix <> 0);
            inc(APC.pc, i);
            if c_flags and _c_section = 0 then begin
              inc(code_size, i); lst_code:= _CPU_byte;
            end { if };
          {$else}
            if i_prefix <> 0 then begin
              gen_byte(_prefix_1);
            end { if };
            gen_byte(i_descr.opcode);
          {$endif} end
        else if i_flags = _i_rel then begin         {    branch }
          {$ifdef lst}     {     ,     }
            i:= 2;
            if special_opcodes then begin
              dec(i);
            end { if };
            inc(APC.pc, i); {  ,       (BRx) }
            if c_flags and _c_section = 0 then begin   { or more (BRclr/set) }
              inc(code_size, i); lst_code:= _rel_byte;     {  relative byte }
              {  ,       APC  _APC }
            end { if };
          {$else}
            if not special_opcodes then begin   {  (BRCLR/BRSET) }
              gen_byte(i_descr.opcode);{generate branch code (if normal case)}
            end { if };

            expression(false, false, false);

            sv_pc:= _apc.pc; _apc.pc:= apc.pc+1;
            case gv.v_kind of
              v_none: ;             { do not display error (already displayed) }
              v_expr,     {       (   ) }
              v_cnst: _gen_rbyte(_APC);            { generate relative address }
            else(*):(*)
              error(e_inv_brnch);                     { invalid branch operand }
            end { case };
            _apc.pc:= sv_pc;
          {$endif}
          special_opcodes:= false { force instruction break } end
        else begin                     {      }
          if special_pass < 2 then force_mode:= 0;   {     }
                                                             {   }
          skip_expr:= false;                                      {$ifdef lst}
	  if c_flags and _c_section = 0 then lst_code:= _CPU_byte;    {$endif}
               {       .   # }
          if sy = dies then begin      {  '#',   immediate }
            force_mode:= i_flags and (_i_imd + _i_wrd);     {      }
            {$ifNdef lst} {  ?      LST }
              if force_mode = 0 then error(e_inv_dies);
            {$endif}
            insy; end
          else if (sy = less_sy) then begin        {  '<',  Zpg }
            force_mode:= i_flags and (_i_Zpg);              {      }
            {$ifNdef lst} {  ?      LST }
              if force_mode = 0 then error(e_inv_Zpg);
            {$endif}
            insy; end
          else if (sy = great_sy) then begin       {  '>',  ABS }
            force_mode:= i_flags and (_i_abs);              {      }
            {$ifNdef lst} {  ?      LST }
              if force_mode = 0 then error(e_inv_Abs);
            {$endif}
            insy; end
          else if (sy = ident) and ((idnm = 'X') or     {   'X' }
                                    (idnm = 'Y')) then begin    {   'Y' }
            xndx:= (idnm = 'X');
            force_mode:= i_flags and _i_ndx;    {     }
            if force_mode = 0 then error(e_inv_ndx);
            insy; {   .     EOL  ;  ,}
	    if (sy = eol_sy) or (sy = comment_line) then begin{  X/Y}
              gv.v_kind:= v_cnst; gv.l:= 0;
              bracket_mode:= false; skip_expr:= true; end
	    else if special_opcodes and (sy = dies) then
              skip_expr:= true
            else if not (sy in [comma, l_bra, plus_sy, period]) then
              error(e_comma)
            else begin
              bracket_mode:= sy = l_bra;     {  x[expr] = x, expr }
              insy;
	    end { if };
	  end { if };

          if not skip_expr then begin
            if (sy <> comma) or 
               (force_mode <> 0) or 
               (i_flags and _i_ndx = 0) then
              expression(false, false, as11)
            else begin
              gv.v_kind:= v_cnst; gv.l:= 0;
            end { if };
          end { if };
          {$ifdef lst}
            if c_flags and _c_section = 0 then inc(code_size, 2);
            inc(APC.pc, 2);
          {$endif}

          if sy = comma then begin      {      expr, x }
            if (special_pass <> 2) or (i_descr.flags and _i_rel =0) then begin
              if force_mode <> 0 then {       mode }
                error(e_xcomma)                        { extra comma on line }
              else begin
                insy;
                if (sy <> ident) or (idnm <> 'X') and (idnm <> 'Y') then
                  error(e_garbage)
                else begin
                  xndx:= (idnm = 'X');
                  force_mode:= i_flags and _i_ndx;  {    }
                  if force_mode = 0 then error(e_inv_ndx);
                  insy;                                {  X  }
                end { if };
              end { if };
            end { if }; end
          else if (force_mode = _i_ndx) and bracket_mode then begin
            if sy = r_bra then
              insy
	    else if skip_expr and special_opcodes and (sy = dies) then begin
              gv.v_kind:= v_cnst; gv.l:= 0; end
            else begin
              error(e_r_bra);
            end { if };
          end { if };

	  case gv.v_kind of
            v_none: { do nothing because of previous error };

            v_expr,       {       }
	    v_cnst: begin
              byte_op:= (gv.v_kind = v_cnst) and (-128 <= gv.l) and (gv.l < 255);
	      case force_mode of
	        _i_imd: begin            {      }
                  if i_prefix > 1 then begin
                    gen_prefix(i_prefix, force_mode);
                  end { if };
		  {$ifdef lst}
                    if special_opcodes then begin
		      if c_flags and _c_section = 0 then begin
		        dec(code_size);
		      end { if };
                      dec(APC.pc);
                    end { if };
                  {$else}
                    if not special_opcodes then gen_byte(i_descr.opcode);
		    _gen_lobytes(e_no_error, 1);
		  {$endif}
	        end { when _i_imd };

	        _i_wrd: begin
                  if i_prefix > 1 then begin
                    gen_prefix(i_prefix, force_mode);
                  end { if };
		  {$ifdef lst}
		    if c_flags and _c_section = 0 then begin
		      inc(code_size); lst_code:= _CPU_word;
		    end { if };
		    inc(APC.pc);
		  {$else}
		    gen_byte(i_descr.opcode);
		    _gen_words(w_not_word, 1);
		  {$endif}
	        end { when _i_wrd };

	        _i_ndx: begin
                  if xndx then
                    gen_prefix(i_prefix, force_mode)
                  else begin
                    gen_prefix(i_prefix, $80);
                  end { if };
		  {$ifNdef lst}
		    gen_byte(shortcard(i_descr.opcode)+add_for_Ndx);
		    _gen_lobytes(w_not_byte, 1);
		  {$endif}
	        end { when _i_ndx };

	        _i_Zpg: begin
                  if i_prefix > 1 then begin
                    gen_prefix(i_prefix, force_mode);
                  end { if };
		  {$ifNdef lst}
		    gen_byte(shortcard(i_descr.opcode)+add_for_Zpg);
		    _gen_lobytes(w_not_byte, 1);
		  {$endif}
	        end { when _i_Zpg };

	        _i_abs: begin
                  if i_prefix > 1 then begin
                    gen_prefix(i_prefix, force_mode);
                  end { if };
		  {$ifdef lst}
		    if c_flags and _c_section = 0 then begin
		      inc(code_size); lst_code:= _CPU_word;
		    end { if };
                    inc(APC.pc);
		  {$else}
		    gen_byte(shortcard(i_descr.opcode)+$30);
		    _gen_words(w_not_word, 1);
		  {$endif}
	        end { when _i_Zpg };

	      else(*):(*)
                if (i_flags and _i_abs = 0) and
                   (i_flags and _i_Zpg <> 0) then begin      { ZeroPage only }
                  if i_prefix > 1 then begin
                    gen_prefix(i_prefix, _i_Zpg);
                  end { if };
		  {$ifNdef lst}
		    gen_byte(shortcard(i_descr.opcode)+add_for_Zpg);
		    _gen_lobytes(w_not_byte, 1);
		  {$endif} end
                else if byte_op and (i_flags and _i_Zpg <> 0) then begin
                  if i_prefix > 1 then begin
                    gen_prefix(i_prefix, _i_Zpg);
                  end { if };
		  {$ifNdef lst}
		    gen_byte(shortcard(i_descr.opcode)+add_for_Zpg);
                    gen_byte(gv.l)
		  {$endif} end
	        else begin
                  if i_prefix > 1 then begin
                    gen_prefix(i_prefix, _i_abs);
                  end { if };
		  {$ifdef lst}
		    if c_flags and _c_section = 0 then begin
		      inc(code_size); lst_code:= _CPU_word;
		    end { if };
                    inc(APC.pc);
		  {$else}
		    gen_byte(shortcard(i_descr.opcode)+$30);
		    _gen_words(w_not_word, 1);
		  {$endif}
	        end { if };
	      end { case };
	    end { when constant };

	  else(*):(*)
	    unimplemented('expression of instruction');
	  end { case };
        end { if };
      until not special_opcodes or            {   BRclr/BRset }
            (special_pass > 1) and (i_descr.flags and _i_rel = 0);
                                                                  {$ifdef lst}
      if special_pass > 1 then begin
        has_prefix:= special_prefix;
      end { if };
      {         ,    OK}
      sy:= comment_line;  {        } {$endif}
    end { _68_instruction };

{-----------------------------------------------------------------------------}
