{-----------------------------------------------------------------------------}
{ Labels handling implementation part.                           (c) 1992 YGP }

  { $define show_get_free}

  type id_ptr = ^id_rec;
       id_rec = record
         left, right: id_ptr;
         case shortcard of
           0: (pname:  packed_name);                           { common usage }
           1: (pname1: integer);                  { length of name is 1 word  }
           2: (pname2: longint);                  { length of name is 2 words }
           3: (pname3: array [0..2] of word);     { length of name is 3 words }
           4: (pname4: array [0..3] of word);     { length of name is 4 words }
           5: (pname5: packed_name);              { length of name is 5 words }
       end { id_rec };

  var id_sizes: packed array [id_types] of shortcard;

  {$ifdef show_get_free}

  procedure w_f(p: pointer; size: cardinal);
  begin
    writeln('freemem'(*)'words'(*), '(',
                     (*) swap(word(p)) {*) l2s(seg(p^)*16+ofs(p^)) {*},
		     ', ', size: 5, ');');
  end { w_f };

  procedure w_g(p: pointer; size: cardinal);
  begin
    writeln('getmem'(*)'words'(*), '(', size: 5, ') = ',
                    (*) swap(word(p)) {*) l2s(seg(p^)*16+ofs(p^)) {*}, ';');
  end { w_g };

  {$endif}

  function search_lab(nmsz: shortcard;
                      (*)const{*)var{*} nm: packed_name;
                      var t: id_tree): idp;
    label quit;
    type ba = packed array [0..9] of shortcard;
    var lp: id_ptr; w, w1, sz_2: cardinal;
  begin { search_lab }
    lp:= t[nmsz-1]; sz_2:= nmsz + nmsz;
    if lp <> nil then begin
      w1:= 10 - sz_2;
      repeat w:= compare(sz_2, nm, w1, lp^.pname, 0);
        if w = sz_2 then
          goto quit
        else if ba(nm)[w1 + w] < ba(lp^.pname)[w] then
          lp:= lp^.left
        else begin
          lp:= lp^.right
        end { if };
      until lp = nil;
    end { if };

  quit:
    if lp = nil then
      search_lab:= nil
    else begin
      search_lab:= addr(lp^.pname[nmsz]);
    end { if };
  end { search_lab };

  function find_lab(nmsz: shortcard;
                    (*)const{*)var{*} nm: packed_name): idp;
    var lidp: idp;
  begin { find_lab }
    lidp:= nil; flvl:= lvl;            {      }
    while (flvl <> nil) and (lidp = nil) do begin
      lidp:= search_lab(nmsz, nm, flvl^.labs);
      if lidp = nil then flvl:= flvl^.prev;
    end { while };
    if lidp = nil then begin
      lidp:= search_lab(nmsz, nm, global_labs);
    end { if };
    find_lab:= lidp;
  end { find_lab };

  function search_id(nmsz: shortcard;
                     (*)const{*)var{*} nm: packed_name;
                     var t: id_tree;
                     var fidp: id_ptr): shortint;
    label quit;
    type ba = packed array [0..9] of shortcard;
    var lp, lp1: id_ptr; w, w1, sz_2: cardinal; where: shortint;
  begin { search_id }
    {    ,   0      fidp   }
    {  ,   -1  1    ,  fidp      }
    {      ,    -1  left, 1 - right.}

    lp:= t[nmsz-1]; where:= 1; lp1:= nil; sz_2:= nmsz + nmsz;
    if lp <> nil then begin
      w1:= 10 - sz_2;
      repeat lp1:= lp; w:= compare(sz_2, nm, w1, lp^.pname, 0);
        if w = sz_2 then begin
          where:= 0;  goto quit; end
        else if ba(nm)[w1 + w] < ba(lp^.pname)[w] then begin
          where:= -1; lp:= lp^.left end
        else begin
          where:= 1;  lp:= lp^.right
        end { if };
      until lp = nil;
    end { if };

  quit:
    fidp:= lp1; search_id:= where;
  end { search_id };

  function insert_lab(nmsz: shortcard;
                      (*)const{*)var{*} nm: packed_name;
                      (*)const{*)var{*} id: identifier;
		      var t: id_tree): idp;
    label quit;
    var lp, lp1: id_ptr; w, w1: cardinal; where: shortint; lidp: idp;
  begin { insert_lab }
    where:= search_id(nmsz, nm, t, lp1);
    if where = 0 then begin
      if id.id_type <> id_defined then begin
        error(e_redef);
      end { if };
      goto quit; end
    else begin
      {$ifdef show_get_free}
      {$endif}
      (*) w:= wordsizeof(pointer)*2 + nmsz; w1:= id_sizes[id.id_type];
          getmemwords(lp, w + w1); fillwords(lp^, w + w1, 0); inc(w1, w1);
      {*) w:= sizeof(pointer)*2 + nmsz*2;   w1:= id_sizes[id.id_type];
          getmem(lp, w+w1); fillchar(lp^, w+w1, 0);                         {*}
      {$ifdef show_get_free}
	w_g(lp, w + w1 (*) div 2 (*));
      {$endif}
    end { if };

    movewords(nm[5-nmsz], lp^.pname, nmsz);
    move(id, lp^.pname[nmsz], w1);

    if lp1 = nil then
      t[nmsz-1]:= lp
    else if where < 0 then
      lp1^.left:= lp
    else begin
      lp1^.right:= lp
    end { if };

  quit:
    lidp:= addr(lp^.pname[nmsz]);
    if id.id_type <= id_expression then begin
      lidp^.rsrv:= lp;
    end { if };
    insert_lab:= lidp;
  end { insert_lab };

  procedure get_idname(fidp: idp; var name: ident_str);
    type wa = array [0..30000] of word;
    var sz: shortcard; llp: id_ptr;
  begin { get_idname }
    sz:= 0; llp:= fidp^.rsrv;
    repeat inc(sz);                                  {   }
    until addr(llp^.pname[sz]) = fidp;
    unpack_ident(sz, packed_name(addr(wa(addr(llp^.pname)^)[sz-5])^), name);
  end { get_idname };

  procedure change_lab(fidp: idp; (*)const{*)var{*} id: identifier);
    label found;
    type ba = packed array [0..9] of shortcard;
    var sz: shortcard;
        llp, wlp, lp, lp1: id_ptr; w, w1, sz_2: cardinal; where: shortint;
        t: ^id_tree; level: level_ptr;
  begin { change_lab }
    sz:= 0; llp:= fidp^.rsrv;
    repeat inc(sz);                                  {   }
    until addr(llp^.pname[sz]) = fidp;
    sz_2:= sz + sz; level:= lvl;              {      }
    repeat
      if level = nil then
        t:= addr(global_labs)
      else begin
        t:= addr(level^.labs); level:= level^.prev;
      end { if };
      lp:= t^[sz-1]; where:= 0; lp1:= nil;
      if lp <> nil then begin
        repeat w:= compare(sz_2, llp^.pname, 0, lp^.pname, 0);
          if w = sz_2 then
            goto found
          else begin
            lp1:= lp;
            if ba(llp^.pname)[w] < ba(lp^.pname)[w] then begin
              where:= -1; lp:= lp^.left end
            else begin
              where:= 1;  lp:= lp^.right
            end { if };
          end { if };
        until lp = nil;
      end { if };
    until (level = nil) and (t = addr(global_labs));
    error(se_cnglb);

  found:           {            }
    (*) w:= wordsizeof(pointer)*2 + sz; w1:= id_sizes[id.id_type];
        getmemwords(wlp, w + w1); fillwords(wlp^, w + w1, 0); inc(w1, w1);
    {*) w:= sizeof(pointer)*2 + sz*2;   w1:= id_sizes[id.id_type];
        getmem(wlp, w+w1); fillchar(wlp^, w+w1, 0);                         {*}
    {$ifdef show_get_free}
      w_g(wlp, w + w1 (*) div 2 (*));
    {$endif}

                     {          }
    movewords(llp^.pname, wlp^.pname, sz);                {   }
    move(id, wlp^.pname[sz], w1);                {     }

                                  {          }
    wlp^.left:= lp^.left; wlp^.right:= lp^.right;   {  L/R  }
    if lp1 = nil then                             {      ? }
      t^[sz-1]:= wlp                                {      }
    else if where = 1 then        { ,         }
      lp1^.right:= wlp                                        {  1   }
    else begin
      lp1^.left:= wlp                   {  -1   (  ) }
    end { if };

	      {          }
    {$ifdef show_get_free}
    (*) w_f(lp, wordsizeof(pointer)*2 +sz +id_sizes[fidp^.id_type]);
    {*) w_f(lp, sizeof(pointer)*2 + sz*2 + id_sizes[fidp^.id_type]);    {*}
    {$endif}
    (*) freememwords(lp, wordsizeof(pointer)*2 +sz +id_sizes[fidp^.id_type]);
    {*) freemem(lp, sizeof(pointer)*2 + sz*2 + id_sizes[fidp^.id_type]);    {*}
  end { change_lab };

  procedure dispose_tree(var t: id_tree; prev: level_ptr; cc_def: boolean);
    var nmsz: cardinal; lidp: idp; undeclared, unresolved, to_globals: id_tree;

    procedure dispose_item(ip: id_ptr);
    begin { dispose_item }
      if ip <> nil then begin
        dispose_item(ip^.left);
        dispose_item(ip^.right);
	if cc_def then begin
	  {$ifdef show_get_free}
	    (*) w_f(ip, wordsizeof(pointer)*2 + nmsz);
	    {*) w_f(ip, sizeof(pointer)*2 + nmsz*2); {*}
	  {$endif}
	  (*) freememwords(ip, wordsizeof(pointer)*2 + nmsz)
	  {*) freemem(ip, sizeof(pointer)*2 + nmsz*2) {*} end
        else begin
	  lidp:= addr(ip^.pname[nmsz]);
	  if lidp^.id_flags and _id_global <> 0 then begin
	    ip^.left:= to_globals[nmsz-1]; to_globals[nmsz-1]:= ip; end
	  else if lidp^.id_type = id_forward then begin
	    ip^.left:= undeclared[nmsz-1]; undeclared[nmsz-1]:= ip; end
	  else if lidp^.id_type = id_expression then begin
	    ip^.left:= unresolved[nmsz-1]; unresolved[nmsz-1]:= ip; end
          else begin
            {$ifdef show_get_free}
              (*) w_f(ip,wordsizeof(pointer)*2+nmsz+ id_sizes[lidp^.id_type])
              {*) w_f(ip,sizeof(pointer)*2+nmsz*2+ id_sizes[lidp^.id_type]){*};
            {$endif}
            (*) freememw(ip,wordsizeof(pointer)*2+nmsz+id_sizes[lidp^.id_type])
            {*) freemem(ip,sizeof(pointer)*2+nmsz*2+id_sizes[lidp^.id_type]){*}
          end { if };
        end { if };
      end { if };
    end { dispose_item };

    procedure insert_un(src: id_tree; var dest: id_tree);
      type wa = array [0..30000] of word;
      var nmsz: shortcard; ip, lidp: id_ptr; wrk: shortint;
    begin { insert_un }
      for nmsz:= 1 to 5 do begin
        ip:= src[nmsz-1];
        while ip <> nil do begin
	  wrk:= search_id(nmsz,
			  packed_name(addr(wa(addr(ip^.pname)^)[nmsz-5])^),
			  dest, lidp);
	  if lidp = nil then
	    dest[nmsz-1]:= ip
	  else begin
	    case wrk of
	       0: error(se_dt_iu);
	       1: lidp^.right:= ip;
	      -1: lidp^.left:= ip;
	    end { case };
	  end { if };
	  lidp:= ip^.left;
	  ip^.left:= nil; ip^.right:= nil;
	  ip:= lidp;
        end { while };
      end { for };
    end { insert_un };

  begin { dispose_tree }
    fillchar(to_globals, sizeof(to_globals), #0);
    fillchar(undeclared, sizeof(undeclared), #0);
    fillchar(unresolved, sizeof(unresolved), #0);

    for nmsz:= 1 to 5 do begin
      {$ifdef show_get_free}
      write('disposing tree at (',
	    (*) swap(word(t[nmsz-1]))
	    {*) l2s(seg(t[nmsz-1]^)*16+ofs(t[nmsz-1]^)) {*}, ') ...');
      {$endif}
      dispose_item(t[nmsz-1]); t[nmsz-1]:= nil;
      {$ifdef show_get_free}
      write('tree disposed.');
      {$endif}
    end { for };

    if not cc_def and (addr(t) <> addr(global_labs)) then begin
      insert_un(unresolved, expr_labs);
      insert_un(to_globals, global_labs);
      if prev = nil then
        insert_un(undeclared, global_labs)
      else begin
        insert_un(undeclared, prev^.labs)
      end { if };
    end { if };
    {$ifdef show_get_free}
    readln;
    {$endif}
  end { dispose_tree };

  (*) segment (*)
  procedure check_tree(unresolved: boolean);
    var nmsz: cardinal; lidp: idp; welst: ex_lstp;

    procedure check_item(ip: id_ptr);
      type wa = array [0..30000] of word;
    begin { check_item }
      if ip <> nil then begin
        check_item(ip^.left);
        check_item(ip^.right);
        lidp:= addr(ip^.pname[nmsz]);
        if lidp^.id_type = id_forward then begin
          unpack_ident(nmsz,
                       packed_name(addr(wa(addr(ip^.pname)^)[nmsz-5])^),
		       idnm);
	  lidp^.id_type:= id_undeclared;
	  {     id_undeclared           }
	  {                 }
	  {             }
	  {  .                                            }
	  welst:= lidp^.elst;
	  while welst <> nil do begin
	    err_sy:= ident;
	    ferror(welst^.expr^.f_no, welst^.expr^.line, e_undecl);
	    welst:= welst^.next;
	  end { while }; end
        else if unresolved and (lidp^.id_type = id_expression) then begin
          unpack_ident(nmsz,
                       packed_name(addr(wa(addr(ip^.pname)^)[nmsz-5])^),
                       idnm);
	  welst:= lidp^.elst;
	  while welst <> nil do begin
	    err_sy:= ident;
	    ferror(welst^.expr^.f_no, welst^.expr^.line, e_unresolv);
	    welst:= welst^.next;
	  end { while };
        end { if };
      end { if };
    end { check_item };

  begin { check_tree }
    for nmsz:= 1 to 5 do begin
      check_item(global_labs[nmsz-1])
    end { for };
    if unresolved then begin
      for nmsz:= 1 to 5 do begin
        check_item(expr_labs[nmsz-1])
      end { for };
    end { if };
  end { check_tree };

{$ifdef myrzel}
  (*) segment (*)
  function calc_tree_size: shortcard;
    var nmsz: cardinal; lidp: idp; welst: ex_lstp; cur_size: shortcard;

    procedure calc_item(ip: id_ptr);
      type wa = array [0..30000] of word;
    begin { calc_item }
      if ip <> nil then begin
        calc_item(ip^.left);
	calc_item(ip^.right);
	lidp:= addr(ip^.pname[nmsz]);

	{        }
	case lidp^.id_type of
	  { id_undeclared,                    { undeclared forward used label }
	  { id_forward,                        { forward declaration of label }
	  { id_expression,                            { unresolved expression }

	  id_address,                                 { byte relative address }
	  id_pg_addr,                                 { page relative address }
	  id_a_addr,                                       { alligned address }
	  id_eword:                    { external identifier (range 0..65535) }
	    cur_size:= 5 { $xxxx };

          id_word:  cur_size:= 5 { $xxxx };                  { range 0..65535 }
          id_nword: cur_size:= 5 { $xxxx };                { range -1..-65536 }
          id_lint:  cur_size:= 9 { $xxxxxxxx };          { full longint range }
          id_real:  cur_size:= 15 { FP exponential };      { real (FP) number }
	  id_defined: { OK };        { identifier for conditional compilation }

        else(*):(*)
	  error(se_xrf);
	end { case };
      end { if };
    end { calc_item };

  begin { calc_tree_size }
    max_size:= 0;
    for nmsz:= 1 to 5 do begin
      calc_item(global_labs[nmsz-1])
    end { for };
  end { calc_tree_size };

{$endif}

  (*) segment (*)
  procedure PrintXref(t: id_tree);
    var xref: text;
        nmsz: cardinal; lidp: idp; welst: ex_lstp; cur_size: shortcard;
        wlong: longint;
        wrks: string[31];

    (*) segment (*)
    procedure print_item(ip: id_ptr);
      type wa = array [0..30000] of word;
    begin { print_item }
      if ip <> nil then begin
        print_item(ip^.left);
        print_item(ip^.right);
	lidp:= addr(ip^.pname[nmsz]);

	{        }
        unpack_ident(nmsz,
                     packed_name(addr(wa(addr(ip^.pname)^)[nmsz-5])^),
                     idnm);
        wrks:= '   ';
	if lidp^.id_flags and _id_used = 0 then wrks[1]:= '?';
	case lidp^.id_type of
	  {id_address: wrks[2]:= '.';                       { absolute address }
          id_pg_addr: wrks[2]:= 'p';                  { page relative address }
          id_a_addr:  wrks[2]:= 'r';                       { alligned address }
          id_eword:   wrks[2]:= 'e';   { external identifier (range 0..65535) }
        end { case };

	write(xref, wrks, idnm(*): -15 {*), '': 15-length(idnm){*}, ' = ');

	case lidp^.id_type of
	  { id_undeclared,                    { undeclared forward used label }
	  { id_forward,                        { forward declaration of label }
	  { id_expression,                            { unresolved expression }

          id_word,                                           { range 0..65535 }
	  id_address,                                 { byte relative address }
	  id_pg_addr,                                 { page relative address }
          id_a_addr:                                       { alligned address }
            write(xref, lidp^.wval:5, ' ($', (*)word{*)w2s{*}(lidp^.wval),')');

	  id_eword:                    { external identifier (range 0..65535) }
            write(xref, '$', (*)word{*)w2s{*}(lidp^.wval));

          id_nword: begin                                  { range -1..-65536 }
            wlong:= lidp^.wval or $ffff0000;
            write(xref, wlong:5, ' ($', (*)word{*)l2s{*}(wlong),')');
          end { when neg word };

          id_lint:                                       { full longint range }
            write(xref, lidp^.lval:5, ' ($', (*)word{*)l2s{*}(lidp^.lval),')');

	  id_defined: { OK };        { identifier for conditional compilation }

          id_real:  unimplemented('FP xref');
        else(*):(*)
	  error(se_xrf);
	end { case };
        writeln(xref);
      end { if };
    end { print_item };

  begin { PrintXref } 
    {   -   ,   -  }
    {          .            }
    {              }
    {                }
    {   .                                          }
    writeln(message, 'Generating cross reference');
    (*) rewrite(xref, xrf_fname^);
    {*) assign(xref, xrf_fname^); rewrite(xref); {*}
    if IOresult <> 0 then begin
      err_str:= xrf_fname; error(e_open);
    end { if };

    {      ,     }
    {  . 							   }
    {      }

    for nmsz:= 1 to 5 do begin
      print_item(global_labs[nmsz-1])
    end { for };
    close(xref);
  end { PrintXref };
{-----------------------------------------------------------------------------}