;---------- Multiply Subroutines (8x8 = 16 bit or 8x16 = 16 bit) -------------;
; On Entry: mply_8x8 -> B, A: two operands    mply_8x16 -> X, A: two operands ;
; On Exit:              BA:= B * A                         BA:= X * A         ;
; Uses:      op1, op1+1, op2                                                  ;
; Unchanged: X register                                                       ;

mply_8x16       proc
                stx     op1
                clrb
                bra     mply_8x8_
mply_8x8        =       *
                stb     op1+1           ; op1
                clrb
                stb     op1             ; op1 = 16 bit operand
mply_8x8_       sta     op2             ; op2
                clra                    ; BA = result (0 at the begining)
                bra     do_lsr
loop            bcc     DontAdd         ;   if HasCarry
                adda    op1+1           ;     then Inc(result, op1);
                adcb    op1
DontAdd         asl     op1+1           ;   op1:= op1 shl 1;
                rol     op1
do_lsr          lsr     op2             ;   op2:= op2 shr 1;
                bne     loop
                bcc     OK_end
                adda    op1+1           ; if carry then Inc(result, op1);
                adcb    op1
OK_end          rts

op1             ds      2               ; or make EQU in zero page
op2             ds      1               ; or make EQU in zero page
                endp; mply_8x16